//|\___METATRADER 4 EXPERT ADVISOR______________________________________________________________\
//|/___NAME: Heiken-Ashi_&_Fisher-Transform__EA.mq4_____________________________________________\
//|\___AUTHOR: Brian Michael Lillard, March, 28. 2013___________________________________________\
//|/___QUOTE: "The_program_needs_programming_and_the_programming_needs_programming"-Brian_______\

// A_N_  A_B_S_T_R_A_C_T_  I_D_E_A_
// OBJECTIVE: Place either a "New trade-order", or, place a "Signal to signl trade-order".
// THEORY: Good indicator confirmations for sizable profits'.
//  1. Heiken-Ashi & Fisher-Transform signals must match to open an order.
//  2. Orders are closed when there is a Stoploss, Takeprofit or a New signal.
// APPLICATIONS: Any Currency, Any Timeframe and either ECN or STP Brokers.
// DEBUG: Print to "Experts tab" Digits, Spread, SpreadPips, and Ticks. Also Tick_Timeout.
// EASE OF USE: Easily change strategies, or order settings, and opened orders are u&da@ed.

#property copyright "Copyright 2013, Brian M. Lillard"
#include <IBFX - Quick Scripts.mqh>//C:\IBFX_0-Click\experts\include\IBFX - Quick Scripts.mqh

extern   string Note1="= Heiken Ashi & Fisher Transform Expert Advisor =";
extern      int Magic=4, Timeframe=60; 
extern     bool SignalToSignal=true;
extern   string HeikenAshi="= Heiken Ashi Indicator =";  //Heiken_Ashi_Ma_20.mq4
extern      int MaPeriod=20, MaMethod=1, HAbar=1;
extern   string Fisher="= Fisher Transform Indicator ="; //fisher.mq4
extern      int Length=6, Price=0, NumBars=0, FTbar=1;
extern   string Note2="= User Settings =";
extern   double Lot=0.10;
extern      int TrailingStart=30; //10=stop loss at 10 when at 25, and increases 1 pip at a time.
extern      int TrailingStop=5;  //25=stoploss modified to 10 and the price determines if stoploss is needed.
extern      int Loss=30, Profit=100, Retries=3, Slippage=3; extern double Spread=3.0;
extern   string Note3="= Debug Options =";
extern     bool ShowComments=True, DrawEntryBars=True, TurnTheSoundOn?=False, TurnTheTickSoundOn?=False;
extern      int tick_timeout=0; extern bool PrintDigits=False, PrintSpread=False, PrintSpreadPips=False, 
                PrintBars=False, PrintTicks=False, PrintTrailingStartStop=True;
         string getHA_Value, getFisherTransform_Value, Order_Comment, Signl="N/A";
         double haOpen0=0, haClose0=0, haOpen1=0, haClose1=0, fClose0=0, fClose1=0, Spreadpips;
            int myBars=0, barCnt=0, tick, signls=-1;


int init(){ 
   tick=tick_timeout; myBars=Bars; Order_Comment="[HAFT("+Timeframe+")]["+Symbol()+"(#"+Magic+")]"+"[TP("+Profit+")][SL("+Loss+")]"; 
   return(0); }

int deinit(){ 
   if(signls >= 0){  
      for(int GoCnt=0; GoCnt<signls; GoCnt++){ 
         ObjectDelete("VBar"+signls);} }
   Comment(""); return(0); }



int start(){
//\_____________________________________________________________________________________________\
//|  
//| DEBUG.
//\_____________________________________________________________________________________________\
   if(PrintDigits){Print("digits.."+Digits);}     
   if(PrintSpread){Print("spread..."+Spread);} 
   Spreadpips=Ask-Bid; if(Digits==3){Spreadpips=Spreadpips*100;} if(Digits==5){Spreadpips=Spreadpips*10000;} 
   if(PrintSpreadPips){Print("Spreadpips..."+DoubleToStr(Spreadpips,1));}
//\_____________________________________________________________________________________________\
//|
//| SPREAD. Logic: DO NOT OPEN ORDERS WITH A HIGH SPREAD.
//|              THE MAX'SPREAD IS DEFINED UNDER "spread".
//\_____________________________________________________________________________________________\
   if(tick==tick_timeout){ 
      if(TurnTheSoundOn? && TurnTheTickSoundOn?){PlaySound("wait.wav");}
      tick=1; if(PrintTicks){Print("...TICK..."+tick);}
      if(Spreadpips>Spread){ 
         Print("Spread Too High To Open...Actual spread is" + Spreadpips + " pips."); return(0); }
      else{tick++; if(PrintTicks){Print("...TICK..."+tick); } } }
//\_____________________________________________________________________________________________\
//| 
//| READ THE INDICATOR SETTING(S), AND PRICES FROM THE 
//| CHART, AND DEFINE NEW SIGNAL(S) FOR EACH INDICATOR.
//\_____________________________________________________________________________________________\
   getHAValue();
   getFisherTransformValue();
//\_____________________________________________________________________________________________\
//
// CHART COMMENTS.
//\_____________________________________________________________________________________________\
   if(ShowComments){
      Comment("[Heiken.Ashi.&.Fisher.Transform] -Metatrader 4 Expert Advisor"+
         "\n"+"[EA.Order.Comment] ="+Order_Comment+
         "\n"+"[Heiken.Ashi.Signal] ="+getHA_Value+
         "\n"+"[Fisher.Transform.Signal] ="+getFisherTransform_Value+
         "\n"+"[SPREAD] "+DoubleToStr(Spreadpips,1)+"//"+DoubleToStr(Spread,1)+
         "\n"+"[SIGNAL] "+Signl); }
   else{Comment(""); }
//\_____________________________________________________________________________________________\
//
// TRAILING(START/STOP).
//\_____________________________________________________________________________________________\
   for(int i=OrdersTotal()-1; i>=0; i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==True){
         if(OrderType()==OP_BUY&&OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic){ 
            TrailOrder(OP_BUY); if(TurnTheSoundOn?){PlaySound("ok.wav");} if(!SignalToSignal){return(0);} }
         if(OrderType()==OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic){ 
            TrailOrder(OP_SELL); if(TurnTheSoundOn?){PlaySound("ok.wav");} if(!SignalToSignal){return(0);}} }
      else{Print("Could not select the trade to trail order");} }
//\_____________________________________________________________________________________________\
// 
// EXECUTE: ONCE EVERY NEW CANDLE.
//\_____________________________________________________________________________________________\
   if(myBars!=Bars){myBars=Bars;}else{return(0); } 
   if(PrintBars){Print("Bar "+barCnt); }
//\_____________________________________________________________________________________________\
//  
// EXECUTE: OPEN ORDER, MODIFY ORDER, OR CLOSE ORDER.
//\_____________________________________________________________________________________________\
   if(getHA_Value=="BUY"&&getFisherTransform_Value=="BUY"&&Signl!="BUY"){ 
         CloseAll(Symbol(),Magic,OP_SELL,Retries,Slippage,Order_Comment);      
         Signl = "BUY"; signls++; //if(TurnTheSoundOn?){PlaySound("ok.wav"); } 
         EnterLong(Symbol(),Lot,Order_Comment,Loss,Profit,Magic,Retries,Slippage); 
         if(DrawEntryBars){CreateVLine("VBar"+signls,true);} }
   if(getHA_Value=="SELL"&&getFisherTransform_Value=="SELL"&&Signl!="SELL"){ 
         CloseAll(Symbol(),Magic,OP_BUY,Retries,Slippage,Order_Comment);
         Signl = "SELL"; signls++; //if(TurnTheSoundOn?){PlaySound("ok.wav"); }
         EnterShrt(Symbol(),Lot,Order_Comment,Loss,Profit,Magic,Retries,Slippage);
         if(DrawEntryBars){CreateVLine("VBar"+signls,false); } } return(0); }  
//\_____________________________________________________________________________________________\
//|                                                                    
//| Summary: We placed either a "new trade-order" or a "signal to signl" trade-order.
//\_____________________________________________________________________________________________\


int CountOrders(int direction){
   int j=0;                                                            
   for(int i=OrdersTotal()-1; i>=0; i--){//                            
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==True){//          
         if(OrderType()==direction&&OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic){
            j++; } }
      else{Print("Could not SELECT trade"); } }
   return(j); }


void CreateVLine(string Name, bool buy){ 
   if(buy){ 
      ObjectCreate(Name,OBJ_VLINE,0,Time[0],Ask); ObjectSet(Name,OBJPROP_COLOR,Red);
      ObjectSet(Name,OBJPROP_STYLE,3); ObjectSet(Name,OBJPROP_WIDTH,0); ObjectSet(Name,OBJPROP_BACK,false); }
   else{ 
      ObjectCreate(Name,OBJ_VLINE,0,Time[0],Bid); ObjectSet(Name,OBJPROP_COLOR,RoyalBlue);
      ObjectSet(Name,OBJPROP_STYLE,3); ObjectSet(Name,OBJPROP_WIDTH,0); ObjectSet(Name,OBJPROP_BACK,false); } }


void getHAValue(){
   getHA_Value="N/A";
   haOpen0=iCustom(NULL,Timeframe,"Heiken_Ashi_Ma_20",MaMethod,MaPeriod,2,HAbar);
   haClose0= iCustom(NULL,Timeframe,"Heiken_Ashi_Ma_20",MaMethod,MaPeriod,3,HAbar);  
   if(haOpen0<haClose0){getHA_Value="BUY";}   //buy
   if(haOpen0>haClose0){getHA_Value="SELL";}} //sell
void getFisherTransformValue(){
   getFisherTransform_Value="N/A";
   fClose0=iCustom(NULL,Timeframe,"fisher",Length,Price,NumBars,0,FTbar);
   fClose1=iCustom(NULL,Timeframe,"fisher",Length,Price,NumBars,1,FTbar);
   if(fClose0<fClose1){getFisherTransform_Value="BUY";}   //buy
   if(fClose0>fClose1){getFisherTransform_Value="SELL";}} //sell


void TrailOrder(int type){
   for(int h; barCnt=OrdersTotal()-1; h>=0; h--){
      if(OrderSelect(h,SELECT_BY_POS,MODE_TRADES)==True&&TrailingStart>0||TrailingStop>0){
         if(OrderMagicNumber()==Magic&&OrderComment()==Order_Comment){
            if(type==OP_BUY){
               double sl=NormalizeDouble(OrderStopLoss()-OrderOpenPrice(),Digits);                   
               double profit=NormalizeDouble(Bid-OrderOpenPrice(),Digits);                        
               if(profit>=Point*TrailingStart+Point*TrailingStop){//We are over the minimum profit by the trail
                  if(sl<Point*TrailingStart){//Move SL to minimum profit                            
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     if(PrintTrailingStartStop){Print("Moved SL to: "+(Bid-Point*TrailingStop));} 
                     if(TurnTheSoundOn?){PlaySound("stops.wav");} return(0);}                      
                  if(profit-sl > Point*TrailingStop){// Keep moving the Trailing Stop up as we have more profit.
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     if(TurnTheSoundOn?){PlaySound("stops.wav");} return(0);} } }
            if(type==OP_SELL){
               sl=NormalizeDouble(OrderOpenPrice()-OrderStopLoss(),Digits);
                  profit=NormalizeDouble(OrderOpenPrice()-Ask,Digits);
                     if(profit>=Point*TrailingStart+Point*TrailingStop){ // We are over the minimum profit by the trail
                        if(sl<Point*TrailingStart){ // Move SL to minimum profit
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red); 
                Print("Moved SL to min " + (Ask+Point*TrailingStop));
               if(TurnTheSoundOn?){PlaySound("stops.wav");} return(0);}
               if(profit-sl > Point*TrailingStop){// Keep moving the Trailing Stop up as we have more profit.
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
               if(TurnTheSoundOn?){PlaySound("stops.wav");} return(0);} } } } } }} 
